#include "pitches.h"
#include "RickRoll.h"
#include "SmoothCriminal.h"

PROGMEM prog_uint16_t endTune[] = {
  NOTE_B5, 100, NOTE_A5, 100, NOTE_G5, 100, NOTE_F5, 100, NOTE_E5, 100, NOTE_D5, 100,
  NOTE_C5, 500, NOTE_00, 500
};
byte endTuneSteps = 8;

unsigned long time = 0;
int tuneStep = 0;


void restart_melody()
{
  time=millis();
  tuneStep=0;
  noTone(speakerPin);
}

boolean playMelody(byte tuneSelect)
{
  boolean retVal=true;
  if (millis() > time) {
    int toneVal = 0;
    int duration = 0;
    if (tuneSelect == ENDTUNE ) {
      if (tuneStep >= endTuneSteps) {
        retVal=false;
        tuneStep=0;
      }
      toneVal=pgm_read_word_near(endTune+(tuneStep*2));
      duration = pgm_read_word_near(endTune+(tuneStep*2)+1);
    } else if (tuneSelect == RICKTUNE ) {
      if (tuneStep >= RickRollTuneSteps) {
        retVal=false;
        tuneStep=0;
      }
      toneVal=pgm_read_word_near(RickRollTune+(tuneStep*2));
      duration = pgm_read_word_near(RickRollTune+(tuneStep*2)+1) / 2;
    } else if (tuneSelect == SMOOTHTUNE ) {
      if (tuneStep >= SmoothCriminalSteps) {
        retVal=false;
        tuneStep=0;
      }
      toneVal=pgm_read_word_near(SmoothCriminalTune+(tuneStep*2));
      duration = pgm_read_word_near(SmoothCriminalTune+(tuneStep*2)+1);
    }
    tuneStep++;
    duration=duration/2;
    if (toneVal) tone(speakerPin,toneVal,duration);
    time=millis()+duration+5;
  }
  return retVal;
}

